package com.fjhx.flow.enums;

import com.ruoyi.common.exception.ServiceException;
import lombok.AllArgsConstructor;
import lombok.Getter;

import java.util.HashMap;
import java.util.Map;

@Getter
@AllArgsConstructor
public enum NodeTypeEnum {

    START(1, "开始"),
    // 通过/不通过，通过后向下一节点流转，不通过则退回上一节点
    EXAMINED(2, "审核"),
    // 同意/驳回，同意后向下一节点流转，驳回则以驳回状态结束本流程
    APPROVAL(3, "审批"),
    // 办理，办理后向下一节点流转
    HANDLE(4, "办理"),
    BRANCH(5, "分支"),
    END(99, "结束");

    private final Integer key;

    private final String value;

    private static final Map<Integer, NodeTypeEnum> map = new HashMap<>();

    static {
        for (NodeTypeEnum value : NodeTypeEnum.values()) {
            map.put(value.getKey(), value);
        }
    }

    public static NodeTypeEnum getEnum(Integer key) {
        NodeTypeEnum nodeTypeEnum = map.get(key);
        if (nodeTypeEnum == null) {
            throw new ServiceException("未知节点类型");
        }
        return nodeTypeEnum;
    }

}
